%% a rezolva problema înseamnă a porni căutarea dintr-o stare inițială
% solve_knight(N, Sol) 
solve_knight(N, Sol) :- State0 = [1/1], fill_board(N, [1/1], Board), reverse(Board, Sol).

%% Path = calea urmată de cal până acum
%% Sol = calea completă, va fi egală cu Path când ajungem într-o stare finală
% fill_board(N, Path, Sol)
fill_board(N, Path, Path) :- N2 is N*N, length(Path, N2), !.
fill_board(N, [S | Rest], Sol) :- arc(N, S, Next), \+member(Next, Rest), fill_board(N, [Next, S | Rest], Sol).
 
%% descrie o tranziție validă între două poziții pe tabla de șah
% arc(N, Prev, Next)
arc(N, X1/Y1, X2/Y2) :-
	member((Dx, Dy), [(-2, -1), (-2, 1), (-1, -2), (-1, 2), (1, -2), (1, 2), (2, -1), (2, 1)]),
	X2 is X1 + Dx, X2 > 0, X2 =< N,
	Y2 is Y1 + Dy, Y2 > 0, Y2 =< N.